
;	NTOLDAPP (Clipboard support for DOS programmes running in NT's VDM.)
;	NTOLDAPP.EXE (DOS TSR part.)
;	NTOLDAPP_D.ASM (main module.)

;	Copyright (C) 1998-01-18 Claus Andr Frber

;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation; either version 2 of the License, or
;	(at your option) any later version.

;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.

;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

.model tiny
.286
.code

.386

org		0100h

start:

; this code is only executed at the first start

		jmp		runonce

		db		'$Name: NTOLDAPP.COM',0
		db		'$Version: 0.91 ALPHA',0
		db		'$Date: 1997-01-18',0
		db 		'$Copyright: Claus Andr',82h,' F',84h,'rber <claus+dev@faerber.muc.de>'
		db		26

start_tsr:
my_int_2f:
		cmp		ah, 17h
		je		oldapp_handler

		db		0eah	; jmp far + a16:a16:
old_int_2f_off:
		dw		0000h
old_int_2f_seg:
		dw		0000h

oldapp_handler:
		push	di		; save di
		mov		di, ax	; use di to pass fct nr, as ax:
		db		0b8h	; mov ax, + i16:
vdd_handle:
		dw		0000h

		dw		0c4c4h		; ntcall:
		db		058h, 02h	; DispatchCall
		pop		di		; restore di
		iret
end_tsr:

moved_start_tsr equ 05ch
moved_end_tsr equ moved_start_tsr + offset end_tsr - offset start_tsr
move_tsr_by equ offset start_tsr - moved_start_tsr

; initialization

runonce:
		push	cs
		push	cs
		pop		ds
		pop		es

		; installation check
		mov		ax,1700h
		push	ax
		int		2Fh
		pop		dx
		cmp		ax,dx
		jne		already_installed

		; dos_get_true_version_number
		mov		ax, 3306h
		int		21h

		cmp		bx,03205h
		jne		not_on_nt

		; RegisterModule()

		mov		si, offset vdd_name
		mov		di, offset vdd_init
		mov		bx, offset vdd_disp

		dw		0c4c4h		; ntcall:
		db		058h,000h	; RegisterModule

		jnc		init_ok

		cmp		ax, 1
		jb		err_oops
		cmp		ax, 4
		ja		err_oops

		mov		bx, ax
		jmp		error_and_term

err_oops:
		xor		bx,bx
		jmp		error_and_term

already_installed:
		mov		bx, 6
		jmp		error_and_term

not_on_nt:
		mov		bx, 5
;		jmp		error_and_term

error_and_term:
		; bx = error nr

		push 	bx
		push 	bx

		; dos_write_string$
		mov		ah,9h
		mov		dx,offset copy_msg
		int 	21h

		pop 	bx

		shl		bx, 1	; bx *= 2
		mov		dx,[bx + error_msg_addr_table]

		; dos_write_string$
		mov		ah,9h
		int 	21h

		; dos_terminate
		pop		bx
		mov		dl,[bx + error_exitcode_table]

		mov		ah, 4ch
		int		21h

init_ok:
		mov		vdd_handle, ax

		; dos_get_int_vector
		mov		ax,0352fh
		int		21h

		mov		old_int_2f_off, bx
		mov		old_int_2f_seg, es

		xor		ax, ax
		mov		[ds:080h], ax

		mov		ax, cs
		mov		es, ax

		mov		cx, offset end_tsr - offset start_tsr

		mov		di, moved_start_tsr
		mov		si, offset start_tsr

		rep	movsb

		; dos_set_int_vector
		mov		dx, offset my_int_2f - move_tsr_by
		mov		ax,0252fh
		int		21h

		; dos_write_string$
;		mov		dx, offset succ_msg
;		mov		ah,9h
;		int 	21h

		; dos_free_memory_block
		mov		ax, [ds:02ch]		; para of environment
		mov		es, ax
		mov		ah,49h
		int		21h

		; dos_terminate_and_stay_resistent
		mov		ax, 3100h
		mov		dx, (15+moved_end_tsr)/16
		int		21h

; strings

copy_msg: db	13,10
		db		'NTOLDAPP/0.9 (C) Claus Andr',82h,' F',84h,'rber',13,10,'$'
ins2_msg: db	'NTOLDAPP: Already loaded (#127).',13,10,'$'
nont_msg: db	'NTOLDAPP: Need Windows NT 3.xx or higher (#255).',13,10,'$'
;succ_msg: db	'Windows NT DOS clipboard support loaded.',13,10,'$'

dllnotfound_msg: db	'NTOLDAPP.DLL: file not found (#250).',13,10,'$'
;dllinitfail_msg: db 'NTOLDAPP.DLL: initialization failed (#192).',13,10,'$'
dllmissentr_msg: db	'NTOLDAPP.DLL: corrupted file or version mismatch. (#252)',13,10,'$'
dlloutofmem_msg: db	'NTOLDAPP.DLL: not enough memory. (#251)',13,10,'$'
dllunkwnerr_msg: db	'NTOLDAPP.DLL: internal error. (#254)',13,10,'$'

error_msg_addr_table:
		dw	offset dllunkwnerr_msg	; RegisterModule ax < 1 / ax > 4

		dw	offset dllnotfound_msg	; RegisterModule ax == 1
		dw	offset dllmissentr_msg	; RegisterModule ax == 2
		dw	offset dllmissentr_msg	; RegisterModule ax == 3
		dw	offset dlloutofmem_msg	; RegisterModule ax == 4

		dw	offset nont_msg
		dw	offset ins2_msg

error_exitcode_table:
		db	254

		db	250
		db	252
		db	252
		db	251

		db	255
		db	127

vdd_name: db	'NTOLDAPP.DLL',0
vdd_init: db	'NTOLDAPP_InitVDD',0
vdd_disp: db	'NTOLDAPP_CallVDD',0

end		start

